ZIP_STAT(3)

NAME
zip_stat, zip_stat_index - get information about file

LIBRARY
libzip (-lzip)

SYNOPSIS
#include <zip.h>
int
zip_stat(struct zip *archive, const char *fname, zip_flags_t flags, struct zip_stat *sb);
int
zip_stat_index(struct zip *archive, int index, zip_flags_t flags, struct zip_stat *sb);

DESCRIPTION
The zip_stat() function obtains information about the file named fname in archive. The flags argument specifies how the name lookup should be done. Its values are described in zip_name_locate(3). Also, ZIP_FL_UNCHANGED may be or'ed to it to request information about the original file in the archive, ignoring any changes made.

The zip_stat_index() function obtains information about the file at position index.

The sb argument is a pointer to a struct zip_stat (shown below), into which information about the file is placed.

    struct zip_stat {
        zip_uint64_t valid;                 /* which fields have valid values */
        const char *name;                   /* name of the file */
        zip_uint64_t index;                 /* index within archive */
        zip_uint64_t size;                  /* size of file (uncompressed) */
        zip_uint64_t comp_size;             /* size of file (compressed) */
        time_t mtime;                       /* modification time */
        zip_uint32_t crc;                   /* crc of file data */
        zip_uint16_t comp_method;           /* compression method used */
        zip_uint16_t encryption_method;     /* encryption method used */
        zip_uint32_t flags;                 /* reserved for future use */
    };

The structure pointed to by sb must be allocated before calling zip_stat() or zip_stat_index().

The valid field of the structure specifies which other fields are valid. Check if the flag defined by the following defines are in valid before accessing the fields:
ZIP_STAT_NAME
    name
ZIP_STAT_INDEX
    index
ZIP_STAT_SIZE
    size
ZIP_STAT_COMP_SIZE
    comp_size
ZIP_STAT_MTIME
    mtime
ZIP_STAT_CRC
    crc
ZIP_STAT_COMP_METHOD
    comp_method
ZIP_STAT_ENCRYPTION_METHOD
    encryption_method
ZIP_STAT_FLAGS
    flags

RETURN VALUES
Upon successful completion 0 is returned. Otherwise, -1 is returned and the error information in archive is set to indicate the error.

ERRORS
The function zip_stat() can fail for any of the errors specified for the routine zip_name_locate(3).

The function zip_stat_index() fails and sets the error information to ZIP_ER_INVAL if index is invalid. If ZIP_FL_UNCHANGED is not set and no information can be obtained from the source callback, the error information is set to ZIP_ER_CHANGED.

SEE ALSO
libzip(3), zip_get_num_entries(3), zip_name_locate(3), zip_stat_init(3)

AUTHORS
-nosplit Dieter Baron <dillo@nih.at> and Thomas Klausner <tk@giga.or.at>